/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser_yacc.y" /* yacc.c:339  */

/*
 *   Copyright (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
 *   NOVELL (All rights reserved)
 *   Copyright (c) 2010-2012
 *   Canonical Ltd.
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, contact Canonical, Ltd.
 */

#define YYERROR_VERBOSE 1
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/apparmor.h>

#include <iostream>

/* #define DEBUG */

#include "parser.h"
#include "profile.h"
#include "mount.h"
#include "dbus.h"
#include "af_unix.h"
#include "parser_include.h"
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <linux/capability.h>

#ifndef CAP_AUDIT_WRITE
#define CAP_AUDIT_WRITE 29
#endif
#ifndef CAP_AUDIT_CONTROL
#define CAP_AUDIT_CONTROL 30
#endif
#ifndef CAP_SETFCAP
#define CAP_SETFCAP	     31
#endif
#ifndef CAP_MAC_OVERRIDE
#define CAP_MAC_OVERRIDE     32
#endif

#define CIDR_32 htonl(0xffffffff)
#define CIDR_24 htonl(0xffffff00)
#define CIDR_16 htonl(0xffff0000)
#define CIDR_8  htonl(0xff000000)

/* undefine linux/capability.h CAP_TO_MASK */
#ifdef CAP_TO_MASK
#undef CAP_TO_MASK
#endif

#define CAP_TO_MASK(x) (1ull << (x))

#define EXEC_MODE_EMPTY		0
#define EXEC_MODE_UNSAFE	1
#define EXEC_MODE_SAFE		2

int parser_token = 0;

struct cod_entry *do_file_rule(char *id, int mode, char *link_id, char *nt);
mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      int mode);
mnt_rule *do_pivot_rule(struct cond_entry *old, char *root,
			char *transition);
void add_local_entry(Profile *prof);


#line 153 "parser_yacc.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser_yacc.h".  */
#ifndef YY_YY_PARSER_YACC_H_INCLUDED
# define YY_YY_PARSER_YACC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 182 "parser_yacc.y" /* yacc.c:355  */

	#include "parser.h"
	#include "profile.h"
	#include "mount.h"
	#include "dbus.h"
	#include "signal.h"
	#include "ptrace.h"
	#include "af_unix.h"

#line 193 "parser_yacc.c" /* yacc.c:355  */

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ID = 258,
    TOK_CONDID = 259,
    TOK_CONDLISTID = 260,
    TOK_CARET = 261,
    TOK_OPEN = 262,
    TOK_CLOSE = 263,
    TOK_MODE = 264,
    TOK_END_OF_RULE = 265,
    TOK_EQUALS = 266,
    TOK_ARROW = 267,
    TOK_ADD_ASSIGN = 268,
    TOK_LE = 269,
    TOK_SET_VAR = 270,
    TOK_BOOL_VAR = 271,
    TOK_VALUE = 272,
    TOK_IF = 273,
    TOK_ELSE = 274,
    TOK_NOT = 275,
    TOK_DEFINED = 276,
    TOK_CHANGE_PROFILE = 277,
    TOK_NETWORK = 278,
    TOK_UNIX = 279,
    TOK_CREATE = 280,
    TOK_SHUTDOWN = 281,
    TOK_ACCEPT = 282,
    TOK_CONNECT = 283,
    TOK_LISTEN = 284,
    TOK_SETOPT = 285,
    TOK_GETOPT = 286,
    TOK_SETATTR = 287,
    TOK_GETATTR = 288,
    TOK_HAT = 289,
    TOK_UNSAFE = 290,
    TOK_SAFE = 291,
    TOK_COLON = 292,
    TOK_LINK = 293,
    TOK_OWNER = 294,
    TOK_OTHER = 295,
    TOK_SUBSET = 296,
    TOK_AUDIT = 297,
    TOK_DENY = 298,
    TOK_ALLOW = 299,
    TOK_PROFILE = 300,
    TOK_SET = 301,
    TOK_ALIAS = 302,
    TOK_PTRACE = 303,
    TOK_OPENPAREN = 304,
    TOK_CLOSEPAREN = 305,
    TOK_COMMA = 306,
    TOK_FILE = 307,
    TOK_MOUNT = 308,
    TOK_REMOUNT = 309,
    TOK_UMOUNT = 310,
    TOK_PIVOTROOT = 311,
    TOK_IN = 312,
    TOK_DBUS = 313,
    TOK_SIGNAL = 314,
    TOK_SEND = 315,
    TOK_RECEIVE = 316,
    TOK_BIND = 317,
    TOK_READ = 318,
    TOK_WRITE = 319,
    TOK_EAVESDROP = 320,
    TOK_PEER = 321,
    TOK_TRACE = 322,
    TOK_TRACEDBY = 323,
    TOK_READBY = 324,
    TOK_RLIMIT = 325,
    TOK_SOFT_RLIMIT = 326,
    TOK_RLIMIT_CPU = 327,
    TOK_RLIMIT_FSIZE = 328,
    TOK_RLIMIT_DATA = 329,
    TOK_RLIMIT_STACK = 330,
    TOK_RLIMIT_CORE = 331,
    TOK_RLIMIT_RSS = 332,
    TOK_RLIMIT_NOFILE = 333,
    TOK_RLIMIT_OFILE = 334,
    TOK_RLIMIT_AS = 335,
    TOK_RLIMIT_NPROC = 336,
    TOK_RLIMIT_MEMLOCK = 337,
    TOK_RLIMIT_LOCKS = 338,
    TOK_RLIMIT_SIGPENDING = 339,
    TOK_RLIMIT_MSGQUEUE = 340,
    TOK_RLIMIT_NICE = 341,
    TOK_RLIMIT_RTPRIO = 342,
    TOK_CAPABILITY = 343,
    TOK_FLAGS = 344
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 192 "parser_yacc.y" /* yacc.c:355  */

	char *id;
	char *flag_id;
	char *mode;
	struct aa_network_entry *network_entry;
	Profile *prof;
	struct cod_net_entry *net_entry;
	struct cod_entry *user_entry;

	mnt_rule *mnt_entry;
	dbus_rule *dbus_entry;
	signal_rule *signal_entry;
	ptrace_rule *ptrace_entry;
	unix_rule *unix_entry;

	flagvals flags;
	int fmode;
	uint64_t cap;
	unsigned int allowed_protocol;
	char *set_var;
	char *bool_var;
	char *var_val;
	struct value_list *val_list;
	struct cond_entry *cond_entry;
	struct cond_entry_list cond_entry_list;
	int boolean;
	struct prefixes prefix;

#line 324 "parser_yacc.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_YACC_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 341 "parser_yacc.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   320

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  90
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  63
/* YYNRULES -- Number of rules.  */
#define YYNRULES  173
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  268

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   344

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   287,   287,   290,   292,   298,   299,   300,   302,   303,
     305,   306,   308,   362,   379,   390,   400,   401,   402,   404,
     412,   439,   467,   487,   497,   508,   514,   515,   523,   528,
     550,   555,   587,   588,   589,   591,   592,   594,   595,   596,
     598,   599,   600,   602,   609,   618,   646,   681,   729,   746,
     762,   778,   794,   810,   830,   849,   858,   868,   874,   973,
     985,   999,  1013,  1018,  1033,  1043,  1053,  1054,  1056,  1057,
    1059,  1060,  1065,  1066,  1068,  1069,  1070,  1072,  1073,  1075,
    1080,  1098,  1109,  1112,  1127,  1136,  1146,  1161,  1174,  1185,
    1199,  1209,  1218,  1219,  1225,  1231,  1232,  1234,  1239,  1244,
    1249,  1254,  1259,  1277,  1278,  1279,  1280,  1281,  1282,  1283,
    1289,  1290,  1291,  1293,  1294,  1295,  1297,  1313,  1347,  1348,
    1349,  1350,  1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,
    1359,  1360,  1361,  1367,  1368,  1369,  1371,  1372,  1373,  1375,
    1391,  1405,  1406,  1407,  1408,  1409,  1415,  1416,  1417,  1419,
    1420,  1421,  1423,  1429,  1447,  1448,  1449,  1450,  1451,  1452,
    1458,  1459,  1460,  1462,  1463,  1464,  1466,  1472,  1473,  1475,
    1483,  1530,  1539,  1540
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ID", "TOK_CONDID", "TOK_CONDLISTID",
  "TOK_CARET", "TOK_OPEN", "TOK_CLOSE", "TOK_MODE", "TOK_END_OF_RULE",
  "TOK_EQUALS", "TOK_ARROW", "TOK_ADD_ASSIGN", "TOK_LE", "TOK_SET_VAR",
  "TOK_BOOL_VAR", "TOK_VALUE", "TOK_IF", "TOK_ELSE", "TOK_NOT",
  "TOK_DEFINED", "TOK_CHANGE_PROFILE", "TOK_NETWORK", "TOK_UNIX",
  "TOK_CREATE", "TOK_SHUTDOWN", "TOK_ACCEPT", "TOK_CONNECT", "TOK_LISTEN",
  "TOK_SETOPT", "TOK_GETOPT", "TOK_SETATTR", "TOK_GETATTR", "TOK_HAT",
  "TOK_UNSAFE", "TOK_SAFE", "TOK_COLON", "TOK_LINK", "TOK_OWNER",
  "TOK_OTHER", "TOK_SUBSET", "TOK_AUDIT", "TOK_DENY", "TOK_ALLOW",
  "TOK_PROFILE", "TOK_SET", "TOK_ALIAS", "TOK_PTRACE", "TOK_OPENPAREN",
  "TOK_CLOSEPAREN", "TOK_COMMA", "TOK_FILE", "TOK_MOUNT", "TOK_REMOUNT",
  "TOK_UMOUNT", "TOK_PIVOTROOT", "TOK_IN", "TOK_DBUS", "TOK_SIGNAL",
  "TOK_SEND", "TOK_RECEIVE", "TOK_BIND", "TOK_READ", "TOK_WRITE",
  "TOK_EAVESDROP", "TOK_PEER", "TOK_TRACE", "TOK_TRACEDBY", "TOK_READBY",
  "TOK_RLIMIT", "TOK_SOFT_RLIMIT", "TOK_RLIMIT_CPU", "TOK_RLIMIT_FSIZE",
  "TOK_RLIMIT_DATA", "TOK_RLIMIT_STACK", "TOK_RLIMIT_CORE",
  "TOK_RLIMIT_RSS", "TOK_RLIMIT_NOFILE", "TOK_RLIMIT_OFILE",
  "TOK_RLIMIT_AS", "TOK_RLIMIT_NPROC", "TOK_RLIMIT_MEMLOCK",
  "TOK_RLIMIT_LOCKS", "TOK_RLIMIT_SIGPENDING", "TOK_RLIMIT_MSGQUEUE",
  "TOK_RLIMIT_NICE", "TOK_RLIMIT_RTPRIO", "TOK_CAPABILITY", "TOK_FLAGS",
  "$accept", "list", "profilelist", "opt_profile_flag", "opt_id",
  "opt_id_or_var", "profile_base", "profile", "local_profile", "hat",
  "preamble", "alias", "varassign", "valuelist", "flags", "opt_flags",
  "flagvals", "flagval", "opt_subset_flag", "opt_audit_flag",
  "opt_owner_flag", "opt_perm_mode", "opt_prefix", "rules", "cond_rule",
  "expr", "id_or_var", "opt_target", "opt_named_transition", "rule",
  "opt_exec_mode", "opt_file", "frule", "file_rule", "file_rule_tail",
  "link_rule", "network_rule", "cond", "opt_conds", "cond_list",
  "opt_cond_list", "mnt_rule", "dbus_perm", "dbus_perms", "opt_dbus_perm",
  "dbus_rule", "net_perm", "net_perms", "opt_net_perm", "unix_rule",
  "signal_perm", "signal_perms", "opt_signal_perm", "signal_rule",
  "ptrace_perm", "ptrace_perms", "opt_ptrace_perm", "ptrace_rule",
  "hat_start", "file_mode", "change_profile", "capability", "caps", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344
};
# endif

#define YYPACT_NINF -214

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-214)))

#define YYTABLE_NINF -27

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -214,    28,    -8,  -214,   112,   115,    31,    96,  -214,  -214,
     138,   138,   144,   133,  -214,  -214,  -214,   160,  -214,  -214,
    -214,   169,   169,  -214,   190,   128,  -214,  -214,   185,  -214,
    -214,    23,  -214,  -214,   221,   231,   193,  -214,  -214,   222,
     239,  -214,    -6,  -214,  -214,   167,  -214,   160,   178,  -214,
    -214,   -24,     2,  -214,   160,  -214,  -214,  -214,   167,   198,
     242,  -214,   243,  -214,  -214,   176,  -214,   183,    27,   147,
       8,    29,   240,  -214,  -214,  -214,  -214,    24,   203,  -214,
    -214,   183,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,   237,  -214,  -214,
    -214,   252,  -214,  -214,   250,   117,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,   128,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
     218,   218,   218,   218,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,   118,   151,  -214,   269,   238,  -214,
    -214,   244,   249,  -214,   107,   219,   253,     1,    67,     5,
     182,  -214,   251,   264,   266,    50,   219,   180,   155,  -214,
    -214,  -214,   245,  -214,     8,   257,   250,   128,   273,  -214,
    -214,   173,  -214,   268,  -214,   278,   128,  -214,    12,  -214,
    -214,    -4,   213,  -214,  -214,  -214,  -214,   128,   279,  -214,
      86,  -214,   280,  -214,   208,  -214,  -214,    20,   128,   111,
     281,  -214,  -214,  -214,   246,  -214,   283,  -214,  -214,   138,
     138,   223,  -214,  -214,  -214,  -214,  -214,  -214,   286,   244,
    -214,  -214,  -214,  -214,  -214,    -2,   102,   289,  -214,   290,
     274,    13,  -214,  -214,  -214,  -214,  -214,  -214
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      16,     0,     3,     1,     0,     0,     0,     2,    17,    18,
       0,     0,     0,     0,   167,   168,     6,     0,     4,     7,
      23,    20,    21,    22,     0,    10,    13,    24,     0,    66,
      67,    25,    11,    19,     0,     0,     0,    27,    44,     0,
      35,    31,     0,    30,    12,     0,    36,     0,     0,    56,
      55,    40,    77,    57,     0,    28,    29,    63,     0,     0,
       0,    14,     0,    42,    41,    37,    44,    74,     0,   136,
      32,   163,    78,    92,    92,    92,    92,   113,   149,   172,
      45,    74,    72,    73,    47,    48,    49,    52,    50,    51,
      53,    54,    15,    62,    64,    65,    44,     0,    38,    39,
      43,    35,    75,    76,     8,     0,    86,   132,   117,   118,
     123,   121,   122,   120,   127,   126,   125,   124,   133,   128,
     129,   119,   130,   131,   137,    92,    34,    33,     0,   159,
     153,   160,   156,   157,   154,   155,   158,   164,    92,    81,
       8,     8,     8,     8,   109,   102,   110,   104,   105,   103,
     106,   107,   108,   114,    92,   145,   140,   146,   141,   142,
     143,   144,   150,    92,     0,     0,    82,    35,     0,    46,
       9,    70,     0,    87,     0,    95,     0,     0,     0,     0,
       0,    93,     0,     0,    68,     0,    95,     0,     0,   173,
     171,   169,     0,    83,    32,    59,     8,     0,     0,    88,
     138,     0,   134,     0,    96,     0,     0,   165,     0,   161,
     166,     0,     0,    97,    92,    99,   100,     0,     0,   115,
       0,   111,     0,   151,     0,   147,   152,    70,     0,     0,
       0,    71,   170,   135,     0,   139,     0,   162,    89,     0,
       0,     0,    69,   101,   112,   116,   148,    84,     0,    70,
      44,    61,    58,    92,    85,     0,     0,     0,    79,     0,
      35,     0,    90,    91,    98,    80,    60,    94
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -214,  -214,  -214,  -214,   -34,  -214,   137,  -214,  -214,  -214,
    -214,  -214,  -214,   -11,  -214,  -214,  -214,   259,   108,  -214,
    -214,  -214,  -214,   -65,    75,   247,  -123,  -214,  -213,  -214,
     225,  -214,  -214,  -214,  -214,  -214,  -214,  -214,   -72,  -214,
     121,  -214,  -173,  -214,  -214,  -214,   -57,  -214,  -214,  -214,
    -181,  -214,  -214,  -214,   -55,  -214,  -214,  -214,   302,   120,
    -214,  -214,  -214
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     7,    17,   171,    31,    26,    18,    49,    50,
       2,     8,     9,    21,    35,    36,    42,    43,   128,    51,
     100,    65,    52,    40,    53,    60,    32,   218,   198,    80,
     104,    81,   193,    82,   166,    83,    84,   181,   140,   204,
     205,    85,   153,   185,   154,    86,   124,   174,   125,    87,
     162,   187,   163,    88,   137,   177,   138,    89,    54,   194,
      90,    91,   164
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      22,   101,   141,   142,   143,   176,   225,     4,     5,    66,
     129,    41,   221,   238,   248,    27,   211,   179,   130,    63,
      64,   129,   126,    29,    67,    68,    69,    34,     3,   130,
     105,   167,   197,   144,    13,    30,   259,   106,   129,     6,
      70,   145,   192,   246,    55,   239,   130,   244,   262,   127,
      71,   207,   208,   175,    72,    73,    74,    75,    76,   144,
      77,    78,   212,   267,   132,   133,   178,   145,   134,   135,
     136,   179,   -26,   146,   231,   132,   133,   210,   131,   134,
     135,   136,   186,   236,   147,   148,   149,   150,   151,   152,
      79,   188,   132,   133,   242,   144,   134,   135,   136,    -5,
     219,   220,    14,   145,   247,   249,   180,   182,   183,   184,
     147,   148,   149,   150,   151,   152,   107,   202,   250,    27,
     172,   189,   209,    10,   108,    11,    12,   173,   190,    45,
      15,    29,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    16,   241,    30,   233,    24,   147,   148,   149,   150,
     151,   152,   263,   237,    29,    20,   107,   200,   201,   179,
     191,    23,   230,    25,   108,   226,    30,   119,   120,   121,
     122,   123,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   261,   107,    57,    61,   260,    27,    58,    59,   155,
     108,    92,   213,    28,   214,    33,   118,   156,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   119,   120,   121,
     122,   123,   155,    94,    95,    98,    99,   155,   102,   103,
     156,   170,   179,   179,   203,   156,   257,   179,   255,   256,
     223,   224,    37,   119,   120,   121,   122,   123,    38,    41,
     158,   159,    39,   160,   161,    14,    97,    44,    62,    96,
     139,   168,   157,   170,   191,   196,   197,    45,    14,   199,
     169,   215,   240,   158,   159,   206,   160,   161,   158,   159,
      45,   160,   161,    15,   216,    14,   229,   195,   217,   234,
      14,    46,   266,   232,    47,    48,    15,    45,   235,   243,
     245,   252,    45,   254,    46,   253,   258,    47,    48,   264,
     265,    56,   228,    15,   251,    93,   165,   222,    15,    19,
       0,    46,   227,     0,    47,    48,    46,     0,     0,    47,
      48
};

static const yytype_int16 yycheck[] =
{
      11,    66,    74,    75,    76,   128,   187,    15,    16,     7,
       9,    17,   185,    17,   227,    17,    11,     4,    17,    43,
      44,     9,    14,     3,    22,    23,    24,     4,     0,    17,
       3,    96,    12,     9,     3,    15,   249,    10,     9,    47,
      38,    17,   165,   224,    50,    49,    17,   220,    50,    41,
      48,    50,    51,   125,    52,    53,    54,    55,    56,     9,
      58,    59,    57,    50,    63,    64,   138,    17,    67,    68,
      69,     4,    49,    49,   197,    63,    64,    10,    49,    67,
      68,    69,   154,   206,    60,    61,    62,    63,    64,    65,
      88,   163,    63,    64,   217,     9,    67,    68,    69,     3,
      50,    51,     6,    17,   227,   228,   140,   141,   142,   143,
      60,    61,    62,    63,    64,    65,     9,   174,     7,    17,
       3,     3,   177,    11,    17,    13,    11,    10,    10,    18,
      34,     3,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    45,   214,    15,   201,    12,    60,    61,    62,    63,
      64,    65,    50,   208,     3,    17,     9,    50,    51,     4,
       9,    17,   196,     3,    17,    10,    15,    60,    61,    62,
      63,    64,    25,    26,    27,    28,    29,    30,    31,    32,
      33,   253,     9,    16,    47,   250,    17,    20,    21,     9,
      17,    54,    10,     3,    12,    10,    49,    17,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    60,    61,    62,
      63,    64,     9,    15,    16,    39,    40,     9,    35,    36,
      17,     3,     4,     4,     5,    17,     3,     4,   239,   240,
      50,    51,    11,    60,    61,    62,    63,    64,     7,    17,
      60,    61,    49,    63,    64,     6,     3,     8,    70,     7,
      10,    14,    49,     3,     9,    17,    12,    18,     6,    10,
       8,    10,    49,    60,    61,    12,    63,    64,    60,    61,
      18,    63,    64,    34,    10,     6,    19,     8,    12,    11,
       6,    42,     8,    10,    45,    46,    34,    18,    10,    10,
      10,    10,    18,    10,    42,    49,    10,    45,    46,    10,
      10,    42,   194,    34,   229,    58,    81,   186,    34,     7,
      -1,    42,   192,    -1,    45,    46,    42,    -1,    -1,    45,
      46
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    91,   100,     0,    15,    16,    47,    92,   101,   102,
      11,    13,    11,     3,     6,    34,    45,    93,    97,   148,
      17,   103,   103,    17,    12,     3,    96,    17,     3,     3,
      15,    95,   116,    10,     4,   104,   105,    11,     7,    49,
     113,    17,   106,   107,     8,    18,    42,    45,    46,    98,
      99,   109,   112,   114,   148,    50,   107,    16,    20,    21,
     115,    96,    70,    43,    44,   111,     7,    22,    23,    24,
      38,    48,    52,    53,    54,    55,    56,    58,    59,    88,
     119,   121,   123,   125,   126,   131,   135,   139,   143,   147,
     150,   151,    96,   115,    15,    16,     7,     3,    39,    40,
     110,   113,    35,    36,   120,     3,    10,     9,    17,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    49,    60,
      61,    62,    63,    64,   136,   138,    14,    41,   108,     9,
      17,    49,    63,    64,    67,    68,    69,   144,   146,    10,
     128,   128,   128,   128,     9,    17,    49,    60,    61,    62,
      63,    64,    65,   132,   134,     9,    17,    49,    60,    61,
      63,    64,   140,   142,   152,   120,   124,   113,    14,     8,
       3,    94,     3,    10,   137,   128,   116,   145,   128,     4,
      94,   127,    94,    94,    94,   133,   128,   141,   128,     3,
      10,     9,   116,   122,   149,     8,    17,    12,   118,    10,
      50,    51,   136,     5,   129,   130,    12,    50,    51,   144,
      10,    11,    57,    10,    12,    10,    10,    12,   117,    50,
      51,   132,   130,    50,    51,   140,    10,   149,   108,    19,
      94,   116,    10,   136,    11,    10,   116,   144,    17,    49,
      49,   128,   116,    10,   132,    10,   140,   116,   118,   116,
       7,   114,    10,    49,    10,   103,   103,     3,    10,   118,
     113,   128,    50,    50,    10,    10,     8,    50
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    90,    91,    92,    92,    93,    93,    93,    94,    94,
      95,    95,    96,    97,    98,    99,   100,   100,   100,   101,
     102,   102,   102,   103,   103,   104,   105,   105,   104,   106,
     106,   107,   108,   108,   108,   109,   109,   110,   110,   110,
     111,   111,   111,   112,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   114,
     114,   114,   115,   115,   115,   115,   116,   116,   117,   117,
     118,   118,   119,   119,   120,   120,   120,   121,   121,   122,
     122,   123,   123,   124,   124,   125,   126,   126,   126,   127,
     127,   127,   128,   128,   129,   130,   130,   131,   131,   131,
     131,   131,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   133,   133,   134,   134,   134,   135,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   137,   137,   137,   138,   138,   138,   139,
     140,   140,   140,   140,   140,   140,   141,   141,   141,   142,
     142,   142,   143,   144,   144,   144,   144,   144,   144,   144,
     145,   145,   145,   146,   146,   146,   147,   148,   148,   149,
     150,   151,   152,   152
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     1,     1,     0,     1,
       0,     1,     6,     2,     2,     2,     0,     2,     2,     5,
       3,     3,     3,     1,     2,     0,     0,     2,     4,     2,
       1,     1,     0,     1,     1,     0,     1,     0,     1,     1,
       0,     1,     1,     3,     0,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     8,     5,
       9,     7,     2,     1,     2,     2,     1,     1,     0,     2,
       0,     2,     1,     1,     0,     1,     1,     0,     1,     4,
       5,     2,     2,     2,     4,     6,     2,     3,     4,     3,
       5,     5,     0,     2,     5,     0,     1,     4,     7,     4,
       4,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     3,     0,     1,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     3,     0,     1,     3,     5,
       1,     1,     1,     1,     1,     1,     0,     2,     3,     0,
       1,     3,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     3,     0,     1,     3,     4,     1,     1,     1,
       5,     3,     0,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 288 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1659 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 3:
#line 290 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1665 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 4:
#line 293 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: list profile\n");
		add_to_list((yyvsp[0].prof));
	}
#line 1674 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 5:
#line 298 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1680 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 6:
#line 299 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 1686 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 7:
#line 300 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 2; }
#line 1692 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 8:
#line 302 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.id) = NULL; }
#line 1698 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 9:
#line 303 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 1704 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 10:
#line 305 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.id) = NULL; }
#line 1710 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 11:
#line 306 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 1716 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 12:
#line 309 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *prof = (yyvsp[-1].prof);
		bool self_stack = false;

		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		parse_label(&self_stack, &prof->ns, &prof->name, (yyvsp[-5].id), true);
		free((yyvsp[-5].id));

		if (self_stack) {
			yyerror(_("Profile names must begin with a '/' or a namespace"));
		}

		/* Honor the --namespace-string command line option */
		if (profile_ns) {
			/**
			 * Print warning if the profile specified a namespace
			 * different than the one specified with the
			 * --namespace-string command line option
			 */
			if (prof->ns && strcmp(prof->ns, profile_ns))
				pwarn("%s: -n %s overriding policy specified namespace :%s:\n",
				      progname, profile_ns, prof->ns);

			free(prof->ns);
			prof->ns = strdup(profile_ns);
			if (!prof->ns)
				yyerror(_("Memory allocation error."));
		}

		prof->attachment = (yyvsp[-4].id);
		if ((yyvsp[-4].id) && !((yyvsp[-4].id)[0] == '/' || strncmp((yyvsp[-4].id), "@{", 2) == 0))
			yyerror(_("Profile attachment must begin with a '/' or variable."));
		prof->flags = (yyvsp[-3].flags);
		if (force_complain && kernel_abi_version == 5)
			/* newer abis encode force complain as part of the
			 * header
			 */
			prof->flags.complain = 1;

		post_process_file_entries(prof);
		post_process_rule_entries(prof);
		PDEBUG("%s: flags='%s%s'\n",
		       (yyvsp[-4].id),
		       prof->flags.complain ? "complain, " : "",
		       prof->flags.audit ? "audit" : "");

		(yyval.prof) = prof;

	}
#line 1773 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 13:
#line 363 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof)->ns)
			PDEBUG("Matched: :%s://%s { ... }\n", (yyvsp[0].prof)->ns, (yyvsp[0].prof)->name);
		else
			PDEBUG("Matched: %s { ... }\n", (yyvsp[0].prof)->name);

		if ((yyvsp[0].prof)->name[0] != '/' && !((yyvsp[-1].boolean) || (yyvsp[0].prof)->ns))
			yyerror(_("Profile names must begin with a '/', namespace or keyword 'profile' or 'hat'."));

		if ((yyvsp[-1].boolean) == 2)
			prof->flags.hat = 1;
		(yyval.prof) = prof;
	}
#line 1793 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 14:
#line 380 "parser_yacc.y" /* yacc.c:1646  */
    {

		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof))
			PDEBUG("Matched: local profile %s { ... }\n", prof->name);
		prof->local = 1;
		(yyval.prof) = prof;
	}
#line 1807 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 15:
#line 391 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *prof = (yyvsp[0].prof);
		if ((yyvsp[0].prof))
			PDEBUG("Matched: hat %s { ... }\n", prof->name);

		prof->flags.hat = 1;
		(yyval.prof) = prof;
	}
#line 1820 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 16:
#line 400 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1826 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 17:
#line 401 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1832 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 18:
#line 402 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ }
#line 1838 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 19:
#line 405 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (!new_alias((yyvsp[-3].id), (yyvsp[-1].id)))
			yyerror(_("Failed to create alias %s -> %s\n"), (yyvsp[-3].id), (yyvsp[-1].id));
		free((yyvsp[-3].id));
		free((yyvsp[-1].id));
	}
#line 1849 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 20:
#line 413 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: set assignment for (%s)\n", (yyvsp[-2].set_var));
		err = new_set_var(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was previously declared", (yyvsp[-2].set_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1879 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 21:
#line 440 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: additive assignment for (%s)\n", (yyvsp[-2].set_var));
		/* do the first one outside the loop, subsequent
		 * failures are indicative of symtab failures */
		err = add_set_value(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was not previously declared, but is being assigned additional values", (yyvsp[-2].set_var));
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 1910 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 22:
#line 468 "parser_yacc.y" /* yacc.c:1646  */
    {
		int boolean, err;
		char *var_name = process_var((yyvsp[-2].bool_var));
		PDEBUG("Matched: boolean assignment (%s) to %s\n", (yyvsp[-2].bool_var), (yyvsp[0].var_val));
		boolean = str_to_boolean((yyvsp[0].var_val));
		if (boolean == -1) {
			yyerror("Invalid boolean assignment for (%s): %s is not true or false",
				(yyvsp[-2].bool_var), (yyvsp[0].var_val));
		}
		err = add_boolean_var(var_name, boolean);
		free(var_name);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[-2].bool_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		free((yyvsp[-2].bool_var));
		free((yyvsp[0].var_val));
	}
#line 1933 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 23:
#line 488 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[0].var_val));

		(yyval.val_list) = val;
	}
#line 1946 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 24:
#line 498 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value list\n");

		list_append((yyvsp[-1].val_list), val);
		(yyval.val_list) = (yyvsp[-1].val_list);
	}
#line 1960 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 25:
#line 508 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */
	flagvals fv = { 0, 0, 0, 0 };

		(yyval.flags) = fv;
	}
#line 1970 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 26:
#line 514 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 1976 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 27:
#line 516 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[-1].id), "flags") != 0)
			yyerror("expected flags= got %s=", (yyvsp[-1].id));
		free((yyvsp[-1].id));
		(yyval.boolean) = 1;
	}
#line 1987 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 28:
#line 524 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 1995 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 29:
#line 529 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[-1].flags).complain = (yyvsp[-1].flags).complain || (yyvsp[0].flags).complain;
		(yyvsp[-1].flags).audit = (yyvsp[-1].flags).audit || (yyvsp[0].flags).audit;
		(yyvsp[-1].flags).path = (yyvsp[-1].flags).path | (yyvsp[0].flags).path;
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_REL | PATH_NS_REL)) ==
		    (PATH_CHROOT_REL | PATH_NS_REL))
			yyerror(_("Profile flag chroot_relative conflicts with namespace_relative"));

		if (((yyvsp[-1].flags).path & (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED)) ==
		    (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED))
			yyerror(_("Profile flag mediate_deleted conflicts with delegate_deleted"));
		if (((yyvsp[-1].flags).path & (PATH_ATTACH | PATH_NO_ATTACH)) ==
		    (PATH_ATTACH | PATH_NO_ATTACH))
			yyerror(_("Profile flag attach_disconnected conflicts with no_attach_disconnected"));
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH)) ==
		    (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH))
			yyerror(_("Profile flag chroot_attach conflicts with chroot_no_attach"));

		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 2020 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 30:
#line 551 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.flags) = (yyvsp[0].flags);
	}
#line 2028 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 31:
#line 556 "parser_yacc.y" /* yacc.c:1646  */
    {
		flagvals fv = { 0, 0, 0, 0 };
		if (strcmp((yyvsp[0].var_val), "debug") == 0) {
			yyerror(_("Profile flag 'debug' is no longer valid."));
		} else if (strcmp((yyvsp[0].var_val), "complain") == 0) {
			fv.complain = 1;
		} else if (strcmp((yyvsp[0].var_val), "audit") == 0) {
			fv.audit = 1;
		} else if (strcmp((yyvsp[0].var_val), "chroot_relative") == 0) {
			fv.path |= PATH_CHROOT_REL;
		} else if (strcmp((yyvsp[0].var_val), "namespace_relative") == 0) {
			fv.path |= PATH_NS_REL;
		} else if (strcmp((yyvsp[0].var_val), "mediate_deleted") == 0) {
			fv.path |= PATH_MEDIATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "delegate_deleted") == 0) {
			fv.path |= PATH_DELEGATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "attach_disconnected") == 0) {
			fv.path |= PATH_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "no_attach_disconnected") == 0) {
			fv.path |= PATH_NO_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_attach") == 0) {
			fv.path |= PATH_CHROOT_NSATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_no_attach") == 0) {
			fv.path |= PATH_CHROOT_NO_ATTACH;
		} else {
			yyerror(_("Invalid profile flag: %s."), (yyvsp[0].var_val));
		}
		free((yyvsp[0].var_val));
		(yyval.flags) = fv;
	}
#line 2063 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 32:
#line 587 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2069 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 33:
#line 588 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2075 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 34:
#line 589 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2081 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 35:
#line 591 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2087 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 36:
#line 592 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2093 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 37:
#line 594 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2099 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 38:
#line 595 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2105 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 39:
#line 596 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 2; }
#line 2111 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 40:
#line 598 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2117 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 41:
#line 599 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 0; }
#line 2123 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 42:
#line 600 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2129 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 43:
#line 603 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.prefix).audit = (yyvsp[-2].boolean);
		(yyval.prefix).deny = (yyvsp[-1].boolean);
		(yyval.prefix).owner = (yyvsp[0].boolean);
	}
#line 2139 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 44:
#line 609 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ 
	Profile *prof = new Profile();
		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		(yyval.prof) = prof;
	}
#line 2152 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 45:
#line 619 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		(yyvsp[0].user_entry)->deny = (yyvsp[-1].prefix).deny;
		if (((yyvsp[-1].prefix).deny && ((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) &&
		     ((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE)))
			yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));
		else if (!(yyvsp[-1].prefix).deny && ((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) &&
			 !((yyvsp[0].user_entry)->mode & ALL_AA_EXEC_TYPE) &&
			 !((yyvsp[0].user_entry)->nt_name))
			yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', 'c', or 'u'"));

		if ((yyvsp[-1].prefix).owner == 1)
			(yyvsp[0].user_entry)->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
		else if ((yyvsp[-1].prefix).owner == 2)
			(yyvsp[0].user_entry)->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS);
		/* only set audit ctl quieting if the rule is not audited */
		if (((yyvsp[-1].prefix).deny && !(yyvsp[-1].prefix).audit) || (!(yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit))
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode & ~ALL_AA_EXEC_TYPE;

		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2182 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 46:
#line 647 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry, *tmp;
		if ((yyvsp[-3].prefix).deny)
			yyerror(_("deny prefix not allowed"));

		PDEBUG("matched: %s%s%sblock\n", (yyvsp[-3].prefix).audit ? "audit " : "",
		       (yyvsp[-3].prefix).deny ? "deny " : "", (yyvsp[-3].prefix).owner ? "owner " : "");
		list_for_each_safe((yyvsp[-1].prof)->entries, entry, tmp) {
			entry->next = NULL;
			if (entry->mode & AA_EXEC_BITS) {
				if (entry->deny &&
				    (entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'"));
				else if (!entry->deny &&
					 !(entry->mode & ALL_AA_EXEC_TYPE))
					yyerror(_("Invalid mode, 'x' must be preceded by exec qualifier 'i', 'p', or 'u'"));
			}
			if ((yyvsp[-3].prefix).owner == 1)
 				entry->mode &= (AA_USER_PERMS | AA_SHARED_PERMS);
			else if ((yyvsp[-3].prefix).owner == 2)
				entry->mode &= (AA_OTHER_PERMS | AA_SHARED_PERMS);

			if ((yyvsp[-3].prefix).audit && !entry->deny)
				entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			else if (!(yyvsp[-3].prefix).audit && entry->deny)
				 entry->audit = entry->mode & ~ALL_AA_EXEC_TYPE;
			add_entry_to_policy((yyvsp[-4].prof), entry);
		}
		(yyvsp[-1].prof)->entries = NULL;
		// fix me transfer rules and free sub profile
		delete (yyvsp[-1].prof);
		(yyval.prof) = (yyvsp[-4].prof);
	}
#line 2220 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 47:
#line 682 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed"));
		if (!(yyvsp[0].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[-2].prof)->alloc_net_table())
			yyerror(_("Memory allocation error."));
		list_for_each_safe((yyvsp[0].network_entry), entry, tmp) {

			/* map to extended mediation if available */
			if (entry->family == AF_UNIX && kernel_supports_unix) {
				unix_rule *rule = new unix_rule(entry->type, (yyvsp[-1].prefix).audit, (yyvsp[-1].prefix).deny);
				if (!rule)
					yyerror(_("Memory allocation error."));
				(yyvsp[-2].prof)->rule_ents.push_back(rule);
			}
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				if ((yyvsp[-1].prefix).deny) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= entry->type;
					if (!(yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= entry->type;
					if ((yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.audit[entry->family] |= entry->type;
				}
			} else {
				if ((yyvsp[-1].prefix).deny) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= 1 << entry->type;
					if (!(yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= 1 << entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= 1 << entry->type;
					if ((yyvsp[-1].prefix).audit)
						(yyvsp[-2].prof)->net.audit[entry->family] |= 1 << entry->type;
				}
			}
			free(entry);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2271 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 48:
#line 730 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on mount rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].mnt_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].mnt_entry)->deny = 1;
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].mnt_entry)->audit = (yyvsp[0].mnt_entry)->allow;
		}

		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].mnt_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2291 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 49:
#line 747 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on dbus rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].dbus_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].dbus_entry)->deny = 1;
			(yyvsp[0].dbus_entry)->audit = (yyvsp[0].dbus_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].dbus_entry)->audit = (yyvsp[0].dbus_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].dbus_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2310 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 50:
#line 763 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on signal rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].signal_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].signal_entry)->deny = 1;
			(yyvsp[0].signal_entry)->audit = (yyvsp[0].signal_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].signal_entry)->audit = (yyvsp[0].signal_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].signal_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2329 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 51:
#line 779 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on ptrace rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].ptrace_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].ptrace_entry)->deny = 1;
			(yyvsp[0].ptrace_entry)->audit = (yyvsp[0].ptrace_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].ptrace_entry)->audit = (yyvsp[0].ptrace_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].ptrace_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2348 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 52:
#line 795 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on unix rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].unix_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].unix_entry)->deny = 1;
			(yyvsp[0].unix_entry)->audit = (yyvsp[0].unix_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].unix_entry)->audit = (yyvsp[0].unix_entry)->mode;
		}
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].unix_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2367 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 53:
#line 811 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("matched: rules change_profile\n");
		PDEBUG("rules change_profile: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `change_profile' returned NULL."));
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on unix rules"));
		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[0].user_entry)->deny = 1;
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[0].user_entry)->deny = 1;
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode;
		} else if ((yyvsp[-1].prefix).audit) {
			(yyvsp[0].user_entry)->audit = (yyvsp[0].user_entry)->mode;
		}
		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2390 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 54:
#line 831 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on capability rules"));

		if ((yyvsp[-1].prefix).deny && (yyvsp[-1].prefix).audit) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
		} else if ((yyvsp[-1].prefix).deny) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
			(yyvsp[-2].prof)->caps.quiet |= (yyvsp[0].cap);
		} else {
			(yyvsp[-2].prof)->caps.allow |= (yyvsp[0].cap);
			if ((yyvsp[-1].prefix).audit)
				(yyvsp[-2].prof)->caps.audit |= (yyvsp[0].cap);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2412 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 55:
#line 850 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'hat rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2424 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 56:
#line 859 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'local_profile rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		add_local_entry((yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2437 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 57:
#line 869 "parser_yacc.y" /* yacc.c:1646  */
    {
		PDEBUG("Matched: conditional rules\n");
		(yyval.prof) = merge_policy((yyvsp[-1].prof), (yyvsp[0].prof));
	}
#line 2446 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 58:
#line 875 "parser_yacc.y" /* yacc.c:1646  */
    {
		rlim_t value = RLIM_INFINITY;
		long long tmp;
		char *end;

		int limit = get_rlimit((yyvsp[-4].id));
		if (limit == -1)
			yyerror("INVALID RLIMIT '%s'\n", (yyvsp[-4].id));

		if (strcmp((yyvsp[-2].var_val), "infinity") == 0) {
			value = RLIM_INFINITY;
		} else {
			const char *kb = "KB";
			const char *mb = "MB";
			const char *gb = "GB";

			tmp = strtoll((yyvsp[-2].var_val), &end, 0);
			switch (limit) {
			case RLIMIT_CPU:
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				tmp = convert_time_units(tmp, SECONDS_P_MS, (yyvsp[-1].id));
				if (tmp == -1LL)
					yyerror("RLIMIT '%s %s' < minimum value of 1s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				else if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				if (!(yyvsp[-1].id))
					pwarn(_("RLIMIT 'cpu' no units specified using default units of seconds\n"));
				value = tmp;
				break;
#ifdef RLIMIT_RTTIME
			case RLIMIT_RTTIME:
				/* RTTIME is measured in microseconds */
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				tmp = convert_time_units(tmp, 1LL, (yyvsp[-1].id));
				if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id))
					pwarn(_("RLIMIT 'rttime' no units specified using default units of microseconds\n"));
				value = tmp;
				break;
#endif
			case RLIMIT_NOFILE:
			case RLIMIT_NPROC:
			case RLIMIT_LOCKS:
			case RLIMIT_SIGPENDING:
#ifdef RLIMIT_RTPRIO
			case RLIMIT_RTPRIO:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id) || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				value = tmp;
				break;
#endif
#ifdef RLIMIT_NICE
			case RLIMIT_NICE:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id))
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (tmp < -20 || tmp > 19)
					yyerror("RLIMIT '%s' out of range (-20 .. 19) %d\n", (yyvsp[-4].id), tmp);
				value = tmp + 20;
				break;
#endif
			case RLIMIT_FSIZE:
			case RLIMIT_DATA:
			case RLIMIT_STACK:
			case RLIMIT_CORE:
			case RLIMIT_RSS:
			case RLIMIT_AS:
			case RLIMIT_MEMLOCK:
			case RLIMIT_MSGQUEUE:
				if ((yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id)) {
					; /* use default of bytes */
				} else if (strstr(kb, (yyvsp[-1].id)) == kb) {
					tmp *= 1024;
				} else if (strstr(mb, (yyvsp[-1].id)) == mb) {
					tmp *= 1024*1024;
				} else if (strstr(gb, (yyvsp[-1].id)) == gb) {
					tmp *= 1024*1024*1024;
				} else {
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id));
				}
				value = tmp;
				break;
			default:
				yyerror("Unknown RLIMIT %d\n", (yyvsp[-4].id));
			}
		}
		(yyvsp[-7].prof)->rlimits.specified |= 1 << limit;
		(yyvsp[-7].prof)->rlimits.limits[limit] = value;
		free((yyvsp[-4].id));
		free((yyvsp[-2].var_val));
		(yyval.prof) = (yyvsp[-7].prof);
	}
#line 2547 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 59:
#line 974 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional rules\n");
		if ((yyvsp[-3].boolean)) {
			ret = (yyvsp[-1].prof);
		} else {
			delete (yyvsp[-1].prof);
		}
		(yyval.prof) = ret;
	}
#line 2562 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 60:
#line 986 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else rules\n");
		if ((yyvsp[-7].boolean)) {
			ret = (yyvsp[-5].prof);
			delete (yyvsp[-1].prof);
		} else {
			ret = (yyvsp[-1].prof);
			delete (yyvsp[-5].prof);
		}
		(yyval.prof) = ret;
	}
#line 2579 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1000 "parser_yacc.y" /* yacc.c:1646  */
    {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else-if rules\n");
		if ((yyvsp[-5].boolean)) {
			ret = (yyvsp[-3].prof);
			delete (yyvsp[0].prof);
		} else {
			ret = (yyvsp[0].prof);
			delete (yyvsp[-3].prof);
		}
		(yyval.prof) = ret;
	}
#line 2596 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1014 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = !(yyvsp[0].boolean);
	}
#line 2604 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1019 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean  = get_boolean_var(var_name);
		PDEBUG("Matched: boolean expr %s value: %d\n", (yyvsp[0].bool_var), boolean);
		if (boolean < 0) {
			/* FIXME check for set var */
			yyerror(_("Unset boolean variable %s used in if-expression"),
				(yyvsp[0].bool_var));
		}
		(yyval.boolean) = boolean;
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2622 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1034 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].set_var));
		void *set_value = get_set_var(var_name);
		PDEBUG("Matched: defined set expr %s value %lx\n", (yyvsp[0].set_var), (long) set_value);
		(yyval.boolean) = !! (long) set_value;
		free(var_name);
		free((yyvsp[0].set_var));
	}
#line 2635 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1044 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean = get_boolean_var(var_name);
		PDEBUG("Matched: defined set expr %s value %d\n", (yyvsp[0].bool_var), boolean);
		(yyval.boolean) = (boolean != -1);
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2648 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1053 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 2654 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1054 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].set_var); }
#line 2660 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1056 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = NULL; }
#line 2666 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1057 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 2672 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1059 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.id) = NULL; }
#line 2678 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1061 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.id) = (yyvsp[0].id);
	}
#line 2686 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1065 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2692 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1066 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2698 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1068 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = EXEC_MODE_EMPTY; }
#line 2704 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1069 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = EXEC_MODE_UNSAFE; }
#line 2710 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1070 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = EXEC_MODE_SAFE; }
#line 2716 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1072 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.boolean) = 0; }
#line 2722 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1073 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.boolean) = 1; }
#line 2728 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1076 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.user_entry) = do_file_rule((yyvsp[-3].id), (yyvsp[-2].fmode), NULL, (yyvsp[-1].id));
	}
#line 2736 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1081 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].boolean) && ((yyvsp[-4].fmode) & ~AA_LINK_BITS))
			yyerror(_("subset can only be used with link rules."));
		if ((yyvsp[-1].id) && ((yyvsp[-4].fmode) & AA_LINK_BITS) && ((yyvsp[-4].fmode) & AA_EXEC_BITS))
			yyerror(_("link and exec perms conflict on a file rule using ->"));
		if ((yyvsp[-1].id) && label_contains_ns((yyvsp[-1].id)) && ((yyvsp[-4].fmode) & AA_LINK_BITS))
			yyerror(_("link perms are not allowed on a named profile transition.\n"));

		if (((yyvsp[-4].fmode) & AA_LINK_BITS)) {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fmode), (yyvsp[-1].id), NULL);
			(yyval.user_entry)->subset = (yyvsp[-3].boolean);

		} else {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fmode), NULL, (yyvsp[-1].id));
		}
 	}
#line 2757 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1099 "parser_yacc.y" /* yacc.c:1646  */
    {
		char *path = strdup("/{**,}");
		int perms = ((AA_BASE_PERMS & ~AA_EXEC_TYPE) |
			     (AA_EXEC_INHERIT | AA_MAY_EXEC));
		/* duplicate to other permission set */
		perms |= perms << AA_OTHER_SHIFT;
		if (!path)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = do_file_rule(path, perms, NULL, NULL);
	}
#line 2772 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1109 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2778 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1113 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].boolean) != EXEC_MODE_EMPTY) {
			if (!((yyvsp[0].user_entry)->mode & AA_EXEC_BITS))
				yyerror(_("unsafe rule missing exec permissions"));
			if ((yyvsp[-1].boolean) == EXEC_MODE_UNSAFE) {
				(yyvsp[0].user_entry)->mode |= (((yyvsp[0].user_entry)->mode & AA_EXEC_BITS) << 8) &
					 ALL_AA_EXEC_UNSAFE;
			}
			else if ((yyvsp[-1].boolean) == EXEC_MODE_SAFE)
				(yyvsp[0].user_entry)->mode &= ~ALL_AA_EXEC_UNSAFE;
		}
		(yyval.user_entry) = (yyvsp[0].user_entry);
	}
#line 2796 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1128 "parser_yacc.y" /* yacc.c:1646  */
    {
		/* Oopsie, we appear to be missing an EOL marker. If we
		 * were *smart*, we could work around it. Since we're
		 * obviously not smart, we'll just punt with a more
		 * sensible error. */
		yyerror(_("missing an end of line character? (entry: %s)"), (yyvsp[-2].id));
	}
#line 2808 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1137 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[-3].id), (yyvsp[-1].id));
		entry = new_entry((yyvsp[-3].id), AA_LINK_BITS, (yyvsp[-1].id));
		entry->subset = (yyvsp[-4].boolean);
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 2821 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1147 "parser_yacc.y" /* yacc.c:1646  */
    {
		size_t family;
		struct aa_network_entry *new_entry, *entry = NULL;
		for (family = AF_UNSPEC; family < get_af_max(); family++) {
			new_entry = new_network_ent(family, 0xffffffff,
						    0xffffffff);
			if (!new_entry)
				yyerror(_("Memory allocation error."));
			new_entry->next = entry;
			entry = new_entry;
		}
		(yyval.network_entry) = entry;
	}
#line 2839 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1162 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-1].id), NULL, NULL);
		if (!entry)
			/* test for short circuiting of family */
			entry = network_entry(NULL, (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2855 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1175 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-2].id), (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-2].id));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 2869 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1186 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent;
		struct value_list *value = new_value_list((yyvsp[0].var_val));
		if (!value)
			yyerror(_("Memory allocation error."));
		ent = new_cond_entry((yyvsp[-2].id), 1, value);
		if (!ent) {
			free_value_list(value);
			yyerror(_("Memory allocation error."));
		}
		(yyval.cond_entry) = ent;
	}
#line 2886 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1200 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 1, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2898 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1210 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 0, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 2910 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1218 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.cond_entry) = NULL; }
#line 2916 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1220 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyvsp[0].cond_entry)->next = (yyvsp[-1].cond_entry);
		(yyval.cond_entry) = (yyvsp[0].cond_entry);
	}
#line 2925 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1226 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.cond_entry_list).name = (yyvsp[-4].id);
		(yyval.cond_entry_list).list = (yyvsp[-1].cond_entry);
	}
#line 2934 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1231 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.cond_entry_list) = { NULL, NULL }; }
#line 2940 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1232 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.cond_entry_list) = (yyvsp[0].cond_entry_list); }
#line 2946 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1235 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), (yyvsp[-1].id), NULL, NULL, AA_MAY_MOUNT);
	}
#line 2954 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1240 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-5].cond_entry), (yyvsp[-4].id), (yyvsp[-2].cond_entry), (yyvsp[-1].id), AA_MAY_MOUNT);
	}
#line 2962 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1245 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_DUMMY_REMOUNT);
	}
#line 2970 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1250 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_MAY_UMOUNT);
	}
#line 2978 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1255 "parser_yacc.y" /* yacc.c:1646  */
    {
		(yyval.mnt_entry) = do_pivot_rule((yyvsp[-3].cond_entry), (yyvsp[-2].id), (yyvsp[-1].id));
	}
#line 2986 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1260 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fmode) = AA_DBUS_BIND;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_DBUS_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_DBUS_RECEIVE;
		else if (strcmp((yyvsp[0].var_val), "eavesdrop") == 0)
			(yyval.fmode) = AA_DBUS_EAVESDROP;
		else if ((yyvsp[0].var_val)) {
			parse_dbus_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3008 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1277 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_BIND; }
#line 3014 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1278 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_SEND; }
#line 3020 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1279 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_RECEIVE; }
#line 3026 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1280 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_RECEIVE; }
#line 3032 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1281 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_SEND; }
#line 3038 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1282 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_DBUS_EAVESDROP; }
#line 3044 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1284 "parser_yacc.y" /* yacc.c:1646  */
    {
		parse_dbus_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3053 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1289 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3059 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1290 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3065 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1291 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3071 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1293 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3077 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1294 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3083 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1295 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3089 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1298 "parser_yacc.y" /* yacc.c:1646  */
    {
		dbus_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("dbus rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new dbus_rule((yyvsp[-3].fmode), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.dbus_entry) = ent;
	}
#line 3108 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1314 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].var_val), "create") == 0)
			(yyval.fmode) = AA_NET_CREATE;
		else if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fmode) = AA_NET_BIND;
		else if (strcmp((yyvsp[0].var_val), "listen") == 0)
			(yyval.fmode) = AA_NET_LISTEN;
		else if (strcmp((yyvsp[0].var_val), "accept") == 0)
			(yyval.fmode) = AA_NET_ACCEPT;
		else if (strcmp((yyvsp[0].var_val), "connect") == 0)
			(yyval.fmode) = AA_NET_CONNECT;
		else if (strcmp((yyvsp[0].var_val), "shutdown") == 0)
			(yyval.fmode) = AA_NET_SHUTDOWN;
		else if (strcmp((yyvsp[0].var_val), "getattr") == 0)
			(yyval.fmode) = AA_NET_GETATTR;
		else if (strcmp((yyvsp[0].var_val), "setattr") == 0)
			(yyval.fmode) = AA_NET_SETATTR;
		else if (strcmp((yyvsp[0].var_val), "getopt") == 0)
			(yyval.fmode) = AA_NET_GETOPT;
		else if (strcmp((yyvsp[0].var_val), "setopt") == 0)
			(yyval.fmode) = AA_NET_SETOPT;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_NET_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_NET_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_net_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3146 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1347 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_CREATE; }
#line 3152 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1348 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_BIND; }
#line 3158 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1349 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_LISTEN; }
#line 3164 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1350 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_ACCEPT; }
#line 3170 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1351 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_CONNECT; }
#line 3176 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1352 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_SHUTDOWN; }
#line 3182 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1353 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_GETATTR; }
#line 3188 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1354 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_SETATTR; }
#line 3194 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1355 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_GETOPT; }
#line 3200 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1356 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_SETOPT; }
#line 3206 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1357 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_SEND; }
#line 3212 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1358 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_RECEIVE; }
#line 3218 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1359 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_RECEIVE; }
#line 3224 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1360 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_NET_SEND; }
#line 3230 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1362 "parser_yacc.y" /* yacc.c:1646  */
    {
		parse_unix_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3239 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1367 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3245 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1368 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3251 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1369 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3257 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1371 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3263 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1372 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3269 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1373 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3275 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1376 "parser_yacc.y" /* yacc.c:1646  */
    {
		unix_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("unix rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new unix_rule((yyvsp[-3].fmode), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.unix_entry) = ent;
	}
#line 3294 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1392 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_MAY_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_MAY_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_signal_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		} else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3312 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1405 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_SEND; }
#line 3318 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1406 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_RECEIVE; }
#line 3324 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1407 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_RECEIVE; }
#line 3330 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1408 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_SEND; }
#line 3336 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1410 "parser_yacc.y" /* yacc.c:1646  */
    {
		parse_signal_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3345 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1415 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3351 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1416 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3357 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1417 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3363 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1419 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3369 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1420 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3375 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1421 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3381 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1424 "parser_yacc.y" /* yacc.c:1646  */
    {
		signal_rule *ent = new signal_rule((yyvsp[-2].fmode), (yyvsp[-1].cond_entry));
		(yyval.signal_entry) = ent;
	}
#line 3390 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1430 "parser_yacc.y" /* yacc.c:1646  */
    {
		if (strcmp((yyvsp[0].var_val), "trace") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fmode) = AA_MAY_TRACE;
		else if (strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fmode) = AA_MAY_READ;
		else if (strcmp((yyvsp[0].var_val), "tracedby") == 0)
			(yyval.fmode) = AA_MAY_TRACEDBY;
		else if (strcmp((yyvsp[0].var_val), "readby") == 0)
			(yyval.fmode) = AA_MAY_READBY;
		else if ((yyvsp[0].var_val))
			parse_ptrace_mode((yyvsp[0].var_val), &(yyval.fmode), 1);
		else
			(yyval.fmode) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3412 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1447 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_TRACE; }
#line 3418 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1448 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_TRACEDBY; }
#line 3424 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1449 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_READ; }
#line 3430 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1450 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_TRACE; }
#line 3436 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1451 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = AA_MAY_READBY; }
#line 3442 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1453 "parser_yacc.y" /* yacc.c:1646  */
    {
		parse_ptrace_mode((yyvsp[0].mode), &(yyval.fmode), 1);
		free((yyvsp[0].mode));
	}
#line 3451 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1458 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3457 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1459 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode) | (yyvsp[0].fmode); }
#line 3463 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1460 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-2].fmode) | (yyvsp[0].fmode); }
#line 3469 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1462 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.fmode) = 0; }
#line 3475 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1463 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[0].fmode); }
#line 3481 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1464 "parser_yacc.y" /* yacc.c:1646  */
    { (yyval.fmode) = (yyvsp[-1].fmode); }
#line 3487 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1467 "parser_yacc.y" /* yacc.c:1646  */
    {
		ptrace_rule *ent = new ptrace_rule((yyvsp[-2].fmode), (yyvsp[-1].cond_entry));
		(yyval.ptrace_entry) = ent;
	}
#line 3496 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1472 "parser_yacc.y" /* yacc.c:1646  */
    {}
#line 3502 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1473 "parser_yacc.y" /* yacc.c:1646  */
    {}
#line 3508 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1476 "parser_yacc.y" /* yacc.c:1646  */
    {
		/* A single TOK_MODE maps to the same permission in all
		 * of user::other */
		(yyval.fmode) = parse_mode((yyvsp[0].mode));
		free((yyvsp[0].mode));
	}
#line 3519 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1484 "parser_yacc.y" /* yacc.c:1646  */
    {
		struct cod_entry *entry;
		int mode = AA_CHANGE_PROFILE;
		int exec_mode = (yyvsp[-3].boolean);
		char *exec = (yyvsp[-2].id);
		char *target = (yyvsp[-1].id);

		if (exec) {
			/* exec bits required to trigger rule conflict if
			 * for overlapping safe and unsafe exec rules
			 */
			mode |= AA_EXEC_BITS;
			if (exec_mode == EXEC_MODE_UNSAFE)
				mode |= ALL_AA_EXEC_UNSAFE;
			else if (exec_mode == EXEC_MODE_SAFE &&
				 !kernel_supports_stacking &&
				 warnflags & WARN_RULE_DOWNGRADED) {
				pwarn("downgrading change_profile safe rule to unsafe due to lack of necessary kernel support\n");
				/**
				 * No need to do anything because 'unsafe' exec
				 * mode is the only supported mode of
				 * change_profile rules in non-stacking kernels
				 */
			}
		} else if (exec_mode != EXEC_MODE_EMPTY)
			yyerror(_("Exec condition is required when unsafe or safe keywords are present"));
		if (exec && !(exec[0] == '/' || strncmp(exec, "@{", 2) == 0))
			yyerror(_("Exec condition must begin with '/'."));

		if (target) {
			PDEBUG("Matched change_profile: tok_id (%s)\n", target);
		} else {
			PDEBUG("Matched change_profile,\n");
			target = strdup("**");
			if (!target)
				yyerror(_("Memory allocation error."));
		}

		entry = new_entry(target, mode, exec);
		if (!entry)
			yyerror(_("Memory allocation error."));

		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 3569 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1531 "parser_yacc.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].cap) == 0) {
			/* bare capability keyword - set all caps */
			(yyval.cap) = 0xffffffffffffffff;
		} else
			(yyval.cap) = (yyvsp[-1].cap);
	}
#line 3581 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1539 "parser_yacc.y" /* yacc.c:1646  */
    { /* nothing */ (yyval.cap) = 0; }
#line 3587 "parser_yacc.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1541 "parser_yacc.y" /* yacc.c:1646  */
    {
		int cap = name_to_capability((yyvsp[0].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[0].id));
		free((yyvsp[0].id));
		(yyval.cap) = (yyvsp[-1].cap) | CAP_TO_MASK(cap);
	}
#line 3599 "parser_yacc.c" /* yacc.c:1646  */
    break;


#line 3603 "parser_yacc.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1549 "parser_yacc.y" /* yacc.c:1906  */

#define MAXBUFSIZE 4096

void vprintyyerror(const char *msg, va_list argptr)
{
	char buf[MAXBUFSIZE];

	vsnprintf(buf, sizeof(buf), msg, argptr);

	if (profilename) {
		PERROR(_("AppArmor parser error for %s%s%s at line %d: %s\n"),
		       profilename,
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	} else {
		PERROR(_("AppArmor parser error,%s%s line %d: %s\n"),
		       current_filename ? " in " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	}
}

void printyyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);
}

void yyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);

	exit(1);
}

struct cod_entry *do_file_rule(char *id, int mode, char *link_id, char *nt)
{
		struct cod_entry *entry;
		PDEBUG("Matched: tok_id (%s) tok_mode (0x%x)\n", id, mode);
		entry = new_entry(id, mode, link_id);
		if (!entry)
			yyerror(_("Memory allocation error."));
		entry->nt_name = nt;
		PDEBUG("rule.entry: (%s)\n", entry->name);
		return entry;
}

/* Note: NOT currently in use, used for 
 * /foo x -> { /bah, }   style transitions
 */
void add_local_entry(Profile *prof)
{
	/* ugh this has to be called after the hat is attached to its parent */
	if (prof->local_mode) {
		struct cod_entry *entry;
		char *trans = (char *) malloc(strlen(prof->parent->name) +
				    strlen(prof->name) + 3);
		char *name = strdup(prof->name);
		if (!trans)
			yyerror(_("Memory allocation error."));
		sprintf(name, "%s//%s", prof->parent->name, prof->name);

		entry = new_entry(name, prof->local_mode, NULL);
		entry->audit = prof->local_audit;
		entry->nt_name = trans;
		if (!entry)
			yyerror(_("Memory allocation error."));

		add_entry_to_policy(prof, entry);
	}
}

static const char *mnt_cond_msg[] = {"",
			 " not allowed as source conditional",
			 " not allowed as target conditional",
			 "",
			 NULL};

int verify_mnt_conds(struct cond_entry *conds, int src)
{
	struct cond_entry *entry;
	int error = 0;

	if (!conds)
		return 0;

	list_for_each(conds, entry) {
		int res = is_valid_mnt_cond(entry->name, src);
		if (res <= 0) {
				printyyerror(_("invalid mount conditional %s%s"),
					     entry->name,
					     res == -1 ? "" : mnt_cond_msg[src]);
				error++;
		}
	}

	return error;
}

mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      int mode)
{
	if (verify_mnt_conds(src_conds, MNT_SRC_OPT) != 0)
		yyerror(_("bad mount rule"));

	/* FIXME: atm conditions are not supported on dst
	if (verify_conds(dst_conds, DST_OPT) != 0)
		yyerror(_("bad mount rule"));
	*/
	if (dst_conds)
		yyerror(_("mount point conditions not currently supported"));

	mnt_rule *ent = new mnt_rule(src_conds, src, dst_conds, dst, mode);
	if (!ent) {
		yyerror(_("Memory allocation error."));
	}

	return ent;
}

mnt_rule *do_pivot_rule(struct cond_entry *old, char *root, char *transition)
{
	char *device = NULL;
	if (old) {
		if (strcmp(old->name, "oldroot") != 0)
			yyerror(_("invalid pivotroot conditional '%s'"), old->name);
		if (old->vals) {
			device = old->vals->value;
			old->vals->value = NULL;
		}
		free_cond_entry(old);
	}

	mnt_rule *ent = new mnt_rule(NULL, device, NULL, root, AA_MAY_PIVOTROOT);
	ent->trans = transition;

	return ent;
}
